%global sover 23

%global forgeurl https://github.com/gismo/gismo
Version:        23.09.0
%forgemeta

Name:           gismo
Release:        %autorelease
Summary:        A C++ library for isogeometric analysis (IGA)
License:        MPL-2.0
URL:            %{forgeurl}
Source0:        %{forgesource}

# https://koji.fedoraproject.org/koji/taskinfo?taskID=109087904
# https://kojipkgs.fedoraproject.org//work/tasks/7917/109087917/build.log
# stat(lib/libgismo.a): Value too large for defined data type.
ExcludeArch:    %{ix86}

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build

%description
G+Smo (Geometry + Simulation Modules, pronounced "gismo") is an open-source C++
library that brings together mathematical tools for geometric design and
numerical simulation. It implements the relatively new paradigm of isogeometric
analysis, which suggests the use of a unified framework in the design and
analysis pipeline. G+Smo is an object-oriented, cross-platform, template C++
library and follows the generic programming principle, with a focus on both
efficiency and ease of use. The library aims at providing access to high
quality, open-source software to the forming isogeometric numerical simulation
community and beyond.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        examples
Summary:        Example files of %{name}

%description    examples
The %{name}-examples package contains example files of %{name}.

%prep
%forgeautosetup -p1

%build
%cmake \
    -GNinja \
    -DCMAKE_BUILD_TYPE=Release \
    -DGISMO_BUILD_UNITTESTS=OFF \
    -DGISMO_PLUGIN_AXL=OFF \
    -DGISMO_WITH_PSOLID=OFF \
    -DLIB_INSTALL_DIR=%{_libdir} \
    -DBIN_INSTALL_DIR=%{_bindir} \
    -DINCLUDE_INSTALL_DIR=%{_includedir} \
    -DCMAKE_INSTALL_DIR=%{_libdir}/cmake/gismo \
    -DTARGET_ARCHITECTURE=none \
    -DCMAKE_SKIP_INSTALL_RPATH=ON \

%cmake_build

%install
%cmake_install
rm %{buildroot}%{_libdir}/libgismo.a
rm %{buildroot}%{_libdir}/cmake/gismo/*.{txt,cxx}

%files
%license COPYRIGHT.txt
%doc README.md
%{_libdir}/libgismo.so.%{sover}*

%files devel
%{_includedir}/gismo/
%{_libdir}/libgismo.so
%dir %{_libdir}/cmake/gismo
%{_libdir}/cmake/gismo/*.cmake

%files examples
%{_bindir}/*_example
%{_bindir}/fitting_mspline
%{_bindir}/gsExpressions_test
%{_bindir}/patches_from_mesh
%{_bindir}/constrained_fitting
%{_bindir}/gsInterpolateMap
%{_bindir}/gsMakeMultiPatch
%{_bindir}/gsPatchFromBoundary
%{_bindir}/gsView
%{_datadir}/gismodata/

%changelog
%autochangelog
